// 扩展API是否准备好，如果没有则监听“plusready"事件
if (window.plus) {
	plusReady();
} else {
	document.addEventListener("plusready", plusReady, false);
}
// 扩展API准备完成后要执行的操作
var shares = null,
	sharewx = null;

function plusReady() {
	//获取分享设备列表
	plus.share.getServices(function(services) {
		shares = services;
		for (var i in shares) {
			var s = shares[i];
			if (s.id == "weixin") {
				sharewx = s;
			}
		}
	}, function(e) {
		showMsg("获取分享服务列表失败：" + e.message);
	});
}

//*************实现微信分享功能**********************
function shareWeixinMessage(extra, options) {
		shareAction(sharewx, extra, options);
	}
	//分享功能

function shareAction(s, ex, options) {
	if (!s) {
		showMsg("无效的分享服务！");
		return;
	}
	//安卓没有nativeClient
	if (s.nativeClient || plus.os.name == 'Android') {
		if (s.authenticated) {
			shareMessage(s, ex, options);
		} else {
			s.authorize(function() {
				shareMessage(s, ex, options);
			}, function(e) {
				showMsg("授权失败");
			});
		}
	} else {
		showMsg("您还没有安装微信客户端！");
	}
}

//分享信息
function shareMessage(s, ex, options) {
	//获取用户存放在本地的ID
	var msg = {
		content: options.content,
		title: options.title,
		thumbs: options.thumbs,
		href: options.href,
		extra: {
			scene: ex
		}
	};
	s.send(msg, function() {}, function(e) {
		//-2为用户手动取消分享
		if (e.code != -2) {
			showMsg('分享到' + s.description + '失败,' + '错误代码：' + e.code + ',错误信息：' + e.message);
		}
	});
}

//取消本次分享授权
function cancelAuth() {
	try {

		for (var i in shares) {
			var s = shares[i];
			if (s.authenticated) {
				showMsg("取消\"" + s.description + "\"");
			}
			s.forbid();
		}
		// 取消授权后需要更新服务列表
		updateServices();
	} catch (e) {
		showMsg(e);
	}
}