ftitAppModule.controller('CustomerController',
	function($scope, $log, $http, $location, Server) {
		// 扩展API是否准备好，如果没有则监听“plusready"事件
		if (window.plus) {
			plusReady();
		} else {
			document.addEventListener("plusready", plusReady, false);
		}
	
		//启动plus监听
		function plusReady() {
			//全局图片存储类
		    var dataf2 = [];
			var returnUrl = $location.path();
			$scope.T_Customer = {};
			$scope.T_Customer.Appellation = '保密';
			// 后台数据工厂实例化
			$scope.server = new Server();
			//初始化验证码接受变量
			$scope.code_phone = "XXMLDSLDHSLDDLLSJDLSLSDJDJLSDJDHFUROOUEWrofnf";
			//检查手机号码输入状态
			var check = {
				oldphone: "",
				oldcode: ""
			};

			$scope.checkPhone = function() {
				var phone = $scope.T_Customer.PhoneNo;
				if (phone == null) {
					showMsg("手机号码为空或者不符合输入要求");
					return true;
				} else if (phone.toString().length != 11) {
					showMsg("手机号码不符合输入要求");
					return true;
				}
				/*验证号码是否已被注册*/
				$scope.server.checkOnlyPhone(returnUrl, phone,
					function(result) {
						if (result.msg != "") {
							//异常处理
							//showMsg("该号码已被注册");
						} else {

						}
						$scope.server.busy = false;
					});
			};

			//检查是否输入过密码
			function checkPasswd() {
				if ($scope.T_Customer.Passwd == null || $scope.T_Customer.Passwd == "") {
					showMsg("请输入密码");
					return true;
				}
				if ($scope.T_Customer.Passwd.length < 6) {
					showMsg("密码长度最少6位");
					return true;
				}
				if ($scope.T_Customer.checkPasswd == null || $scope.T_Customer.checkPasswd == "") {
					showMsg("请输入确认密码");
					return true;
				}
				if ($scope.T_Customer.Passwd != $scope.T_Customer.checkPasswd) {
					showMsg("您第二次输入的密码不正确");
					return true;
				}
			}

			//检查验证码输入
			$scope.checkCode = function() {
				if ($scope.code == null) {
					showMsg("验证码输入异常");
					return true;
				};
				if ($scope.code != $scope.code_phone) {
					showMsg("验证码错误");
					return true;
				};
				if (check.oldphone != $scope.str_phone_no) {
					showMsg("验证码错误");
					return true;
				};
			};

			//验证码获取按钮计时器
			var times = 60;
			var timer = null;
			//获取验证码按钮状态文本
			$scope.changev = {
				checkBool: true,
				strtext: "获取验证码"
			};
			$scope.$digest();
			$scope.updateClock = function(checktype, strtext) {
				$scope.changev.checkBool = checktype;
				$scope.changev.strtext = strtext;
				if (times <= 0) {
					clearInterval(timer); //清除定时器
					times = 60;
				}
			};
			$scope.changebtn = function() {
				timer = setInterval(function() {
					if (times <= 0) {
						$scope.$apply($scope.updateClock(true, "获取验证码"));
					} else {
						$scope.$apply($scope.updateClock(false, times.toString() + "s后重新获取"));
					}
					times--;
				}, 1000);
			};


			// 获取验证码
			$scope.getVerificationCode = function() {
				if ($scope.checkPhone()) {
					return;
				}
				
				//执行验证码按钮控制计时器
				$scope.changebtn();
				//记录当前申请验证码的号码和验证码
				check = {
					oldphone: $scope.str_phone_no,
					oldcode: $scope.code_phone
				};
                
				//调用服务器接口获取验证码
				$scope.server.getVerificationCode(returnUrl, $scope.T_Customer.PhoneNo,
					function(result) {
						if (result.msg != "") {
							//异常处理
							showMsg(result.msg);
						} else {
							$scope.code_phone = result.code;
						}
						$scope.server.busy = false;
					});
			};

			$scope.selectSex = function() {
				plus.nativeUI.actionSheet({
					title: '请选择性别',
					cancel: '取消',
					buttons: [{
						title: '男士'
					}, {
						title: '女士'
					}, {
						title: '保密'
					}]
				}, function(e) {
					console.log(e.index);
					if (e.index == 1) {
						$scope.T_Customer.Appellation = '男士';
						$scope.$digest();
					} else if(e.index==2) {
						$scope.T_Customer.Appellation = '女士';
						$scope.$digest();
					}else{
						$scope.T_Customer.Appellation = '保密';
						$scope.$digest();
					}
				});
			}

			$scope.openNewView = function() {
				//检查电话号码输入
				if ($scope.checkPhone()) {
					return;
				} else {
					$scope.T_Customer.NickName = "昵称_" + $scope.T_Customer.PhoneNo;
				}
				///检查密码输入
				if (checkPasswd()) {
					return;
				}

				//检查性别
				if (!$scope.T_Customer.Appellation) {
					plus.nativeUI.toast('请选择性别');
					return;
				}
				if ($scope.checkCode()) {
					return;
				}
				
				$scope.t_user_info = {
					phone:$scope.T_Customer.PhoneNo,
					password:$scope.T_Customer.Passwd,
					sex:$scope.T_Customer.Appellation,
					photoUrl:''
				};
				if(dataf2=="")
				{
					plus.nativeUI.toast('请上传名片/营业执照');
					return;
				}
				
				plus.nativeUI.confirm("是否提交您的证件图片", function(e) {
				var varfile = reSetImageString(dataf2);
				if (e.index == 1) {
					mui.post(GetServiceAddress() + "RC_Customer/UploadImage", {
							files: varfile
						}, function(data) {
							$scope.t_user_info.photoUrl=data.msg;
					   
							mui.post(GetServiceAddress() + "RC_Customer/save", $scope.t_user_info, function(result) {
							if (result.status == "success") {
								showMsg(result.msg);
								openview("login.html", "login.html", "", "");
							}
							if (result.msg != "") {
								showMsg(result.msg);
							} else {
								//缓存用户信息
								window.localStorage.setItem("phone", result.t_user_info.phone);
								window.localStorage.setItem("password", result.t_user_info.password);
								window.localStorage.setItem("sex", result.t_user_info.sex);
								//openview("login.html", "login.html", "", "");
								//window.history.back('-1');
								//plus.webview.currentWebview().loadURL('submit.html');
								openview("main.html", window.localStorage.getItem("phone"), window.localStorage.getItem("password"), true);
							}
						}, "json");
							
						}, "json");
				}
	        }, "人材日记", ["取消", "确定"]);
				

			}
			
			
			$scope.registpic= function(imgid) {
				plus.nativeUI.actionSheet({
					cancel: '取消',
					buttons: [{
						title: '相册'
					}, {
						title: '拍照'
					}]
				}, function(e) {
					if (e.index == 1) {
						galleryImgs(imgid, dataf2);
					} else if (e.index == 2) {
						cameraimages(imgid, dataf2);
					}
			});
        };


//						mui.back = function() {
//							if (confirm('确定退出？')) {
//								window.history.back('-1');
//							}
//						};
		}
	}
);