﻿/**
 * Created by kevin on 10/30/14.
 */
var ftitAppModule = angular.module('ftitApp', []);
/**
 * Created by kevin on 10/30/14.
 */
// 创建后台数据工厂
ftitAppModule.factory('Server', function($http, $log) {
	//初始化数据操作类工厂
	var Server = function() {
		this.busy = false;
	};
	//定义主服务接口地址
	/*Server.prototype.mainURL = "http://112.74.124.92/";*/
	Server.prototype.mainURL = GetServiceAddress();
	// 保存用户
	Server.prototype.customerSave = function(returnUrl, T_Customer, callback) {
		if (this.busy) return;
		this.busy = true;
		$http({
			method: "POST",
			url: Server.prototype.mainURL + "T_Customer/save",
			data: T_Customer
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				openview("login.html", "login.html", "", "yes");
			}
		}.bind(this));
	};

	//登录
	Server.prototype.loginSystem = function(returnUrl, T_Customer, callback) {
		if (this.busy) return;
		this.busy = true;
		$http({
			method: 'POST',
			url: Server.prototype.mainURL + "RC_Customer/login",
			data: T_Customer
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				openview("login.html", "login.html", "", "yes");
			}
		}.bind(this));
	};

	//检索用户余额列表
	Server.prototype.queryAccountList = function(returnUrl, T_AccountList, callback) {
		if (this.busy) return;
		this.busy = true;
		$http({
			method: 'POST',
			url: Server.prototype.mainURL + "T_AccountList/query",
			data: T_AccountList
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				openview("login.html", "login.html", "", "yes");
			}
		}.bind(this));
	};

	//检索优惠卷列表
	Server.prototype.queryM_CouPonDetail = function(returnUrl, userID, callback) {
		if (this.busy) return;
		this.busy = true;
		$http({
			method: 'get',
			url: Server.prototype.mainURL + "M_CouPonDetail/query?userid=" + userID,
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				openview("login.html", "login.html", "", "yes");
			}
		}.bind(this));
	};

	//修改用户
	Server.prototype.updateCustomer = function(returnUrl, T_Customer, callback) {
		if (this.busy) return;
		this.busy = true;
		$http({
			method: 'POST',
			url: Server.prototype.mainURL + "RC_Customer/update",
			data: T_Customer
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				window.location = "../Admin/Auth/Login?" + returnUrl;
			}
		}.bind(this));
	};
	//修改用户密码
	Server.prototype.updatepwd = function(returnUrl, T_Customer, callback) {
		if (this.busy) return;
		this.busy = true;
		$http({
			method: 'POST',
			url: Server.prototype.mainURL + "T_Customer/updatePwd",
			data: T_Customer
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				window.location = "../Admin/Auth/Login?" + returnUrl;
			}
		}.bind(this));
	};
	
	// 向指定电话号码发送验证码
	Server.prototype.getVerificationCode = function(returnUrl, str_phone_no, callback) {
		if (this.busy) this.busy = false;
		this.busy = true;
		$http({
			method: 'GET',
			url: Server.prototype.mainURL + "RC_Customer/ForgetPwdVerification?phone=" + str_phone_no
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				window.location = "../Admin/Auth/Login?" + returnUrl;
			}
		}.bind(this));
	};

	// 检查当前手机是否已经被注册
	Server.prototype.checkOnlyPhone = function(returnUrl, str_phone_no, callback) {
		if (this.busy) return;
		this.busy = true;
		$http({
			method: 'GET',
			url: Server.prototype.mainURL + "RC_Customer/checkonlyphone?phone=" + str_phone_no
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {

			}
		}.bind(this));
	};

	// 获取菜单列表
	Server.prototype.getMenus = function(returnUrl, itemsPerPage, currentPage, callback) {
		if (this.busy) return;
		this.busy = true;

		$http({
			method: 'GET',
			url: "../Admin/Menu/List?itemsPerPage=" + itemsPerPage + "&currentPage=" + currentPage
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				window.location = "../Admin/Auth/Login?" + returnUrl;
			}
		}.bind(this));
	};


	// 根据菜单ID发布菜单
	Server.prototype.publishMenuByID = function(returnUrl, menuIDs, callback) {
		if (this.busy) return;
		this.busy = true;

		$http({
			method: 'POST',
			url: "../Admin/Menu/PublishMenuByID",
			data: {
				"menuIDs": menuIDs
			}
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				window.location = "../Admin/Auth/Login?" + returnUrl;
			}
		}.bind(this));
	};

	// 根据菜单ID取消发布菜单
	Server.prototype.unPublishMenuByID = function(returnUrl, menuIDs, callback) {
		if (this.busy) return;
		this.busy = true;

		$http({
			method: 'POST',
			url: "../Admin/Menu/UnPublishMenuByID",
			data: {
				"menuIDs": menuIDs
			}
		}).success(function(data) {
			callback(data);
			this.busy = false;
		}).error(function(data, status) {
			// 如果属于用户登录问题，需要返回登录页面
			if (status == 401) {
				window.location = "../Admin/Auth/Login?" + returnUrl;
			}
		}.bind(this));
	};

	return Server;
});

//文件上传自定义指令
ftitAppModule.directive("fileread", [

	function() {
		return {
			scope: {
				fileread: "="
			},
			link: function(scope, element, attributes) {
				element.bind("change", function(changeEvent) {
					var reader = new FileReader();
					reader.onload = function(loadEvent) {
						scope.$apply(function() {
							scope.fileread = loadEvent.target.result;
						});
					}
					reader.readAsDataURL(changeEvent.target.files[0]);
				});
			}
		}
	}
]);

ftitAppModule.directive('appFilereader', function($q) {
	var slice = Array.prototype.slice;

	return {
		restrict: 'A',
		require: '?ngModel',
		link: function(scope, element, attrs, ngModel) {
				if (!ngModel) return;

				ngModel.$render = function() {};

				element.bind('change', function(e) {
					var element = e.target;

					$q.all(slice.call(element.files, 0).map(readFile))
						.then(function(values) {
							if (element.multiple) ngModel.$setViewValue(values);
							else ngModel.$setViewValue(values.length ? values[0] : null);
						});

					function readFile(file) {
						var deferred = $q.defer();

						var reader = new FileReader();
						reader.onload = function(e) {
							deferred.resolve(e.target.result);
						};
						reader.onerror = function(e) {
							deferred.reject(e);
						};
						reader.readAsDataURL(file);

						return deferred.promise;
					}

				}); //change

			} //link
	}; //return
});